NagamochiIbaraki< GR, CM, TR >::SetStandardHeap< H, CR > Struct Template Reference

- Main Page
- Modules
- Classes
- Namespaces
- Files
- Related Pages

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
List of all members
NagamochiIbaraki< GR, CM, TR >::SetStandardHeap< H, CR > Struct Template Reference

## Detailed Description

### template<typename GR, typename CM, typename TR>
template<class H, class CR = RangeMap<int>>
struct lemon::NagamochiIbaraki< GR, CM, TR >::SetStandardHeap< H, CR >

Named parameter for setting heap and cross reference type with automatic allocation. They should have standard constructor interfaces to be able to automatically created by the algorithm (i.e. the graph should be passed to the constructor of the cross reference and the cross reference should be passed to the constructor of the heap). However, external heap and cross reference objects could also be passed to the algorithm using the heap() function before calling run() or init(). The heap has to maximize the priorities.

See Also
  SetHeap

`#include <lemon/nagamochi_ibaraki.h>`

Inheritance diagram for NagamochiIbaraki< GR, CM, TR >::SetStandardHeap< H, CR >:
[legend]

## Additional Inherited Members
Public Types inherited from NagamochiIbaraki< Graph, CapacityMap, SetStandardHeapTraits< H, CR > >
typedef Traits::Graph | Graph
| The type of the underlying graph.
typedef Traits::CapacityMap | CapacityMap
| The type of the capacity map.
typedef Traits::CapacityMap::Value | Value
| The value type of the capacity map.
typedef Traits::Heap | Heap
| The heap type used by the algorithm.
typedef Traits::HeapCrossRef | HeapCrossRef
| The cross reference type used for the heap.
Public Member Functions inherited from NagamochiIbaraki< Graph, CapacityMap, SetStandardHeapTraits< H, CR > >
| NagamochiIbaraki (const Graph &graph, const CapacityMap &capacity)
| Constructor. More...
| NagamochiIbaraki (const Graph &graph)
| Constructor. More...
| ~NagamochiIbaraki ()
| Destructor. More...
NagamochiIbaraki & | heap (Heap &hp, HeapCrossRef &cr)
| Sets the heap and the cross reference used by algorithm. More...
void | init ()
| Initializes the internal data structures. More...
bool | processNextPhase ()
| Processes the next phase. More...
void | start ()
| Executes the algorithm. More...
void | run ()
| Runs NagamochiIbaraki algorithm. More...
Value | minCutValue () const
| Returns the min cut value. More...
Value | minCutMap (CutMap &cutMap) const
| Returns a min cut in a NodeMap. More...